#include "common/soapHello_USCOREBindingService.h"
#include "common/Hello_USCOREBinding.nsmap"
#include <cstdlib>
#include <iostream>
using namespace std;

// ==================================================================
// implementation of 'sayHello' method of service
// ==================================================================
int Hello_USCOREBindingService::sayHello(std::string firstName, /* input */
	std::string &greeting /* output */) {
	
	greeting = "Hello " + firstName;
	return SOAP_OK;
}

// ==================================================================
// main function
// ==================================================================
int main(int argc, char **argv) { 
	// define service on server side
	Hello_USCOREBindingService service;
	
	// use first argument as service port, should be 8080
	if (argc < 2) {
    	service.serve();       /* serve as CGI application */
  	} else { 
  		int port = atoi(argv[1]);
    	if (!port) { 
    		cerr << "Usage: server.exe <port>" << endl;
      		exit(EXIT_FAILURE);
    	}
    	
    	/* run iterative server on port until fatal error */
    	if (service.run(port)) { 
    		service.soap_stream_fault(std::cerr);
      		exit(EXIT_FAILURE);
    	}
  	}

  	return EXIT_SUCCESS;
} 


